_ENV = AIContext

function init_standard_planning_data()

  local _TRACE_INFO=empire.name

  init_mobile_power()

  init_threatened_table()

  calc_potential_expansion_sites()


  --update_defensive_priorities()

  init_fleet_tables()
  init_navy_plans()

  init_handle_production_data()
  for k,v in spairs | init_production_desire
    v()
  end

  init_desired_colony_ships()  
  init_desired_tradeships()

  init_fleet_priorities()
  update_production_desire.outpost()
end

local get_ship_design = weak_memoizeNN | function(ship)
  return Design.clone(ship.source_design)
end

local get_planet_defense_design = weak_memoizeNN | function(planet)
  for design_key, src_design ; planet.empire.designs
    if src_design.planet_info?.defenses==planet.defenses
      return src_design
    end
  end
  print(planet.name, planet.defenses)
  error("no design for planet")
end

function ship_power_score(ship)
  local mult = 1
  if ship.empire == empire
    mult = 1 - ( (ship.armor_damage or 0 )+(ship.structure_damage or 0) ) / (ship.armor+ship.structure)
  end

  local design = get_ship_design | ship
  local combat_power = design_combat_value(design)

  return mult*combat_power
end


function planet_defense_value(planet)
  local planet_defenses = 0

  for _,orbital in pairs(planet.orbitals or _empty) do
    if next | orbital.weapons?
      planet_defenses += ship_power_score | orbital
    end
  end

  if planet.defenses and planet.defenses > 0
    planet_defenses += 0.75*(design_combat_value | get_planet_defense_design | planet)
  end

  return planet_defenses
end