_ENV = AIContext

Empire.known_intel = weak_memoize_n_to_n | function(empire, other)
  --if not in contact, we don't know anything
  --maybe someday we can retain a memory of what each empire has seen
  if not empire.contactable_empires[other]
    return
  end

  return {
    empire = other,
    hostile = at_war(empire,other),
    research = other:research(),
    navy_power = total_navy_power(other),
    --add more fields as needed
  }
end

Empire.is_at_war = weak_memoizeNN | function(empire)
  for other ; empire.known_empires
    if (not other.is_minor) and (not other.eliminated) and ( at_war(empire,other) )
      return true
    end
  end
end

-- if we're at war, consider the naval power of all enemies
-- otherwise only consider the naval power of the strongest rival
-- also calculate the median naval power, to get a sense of where we stand
-- with respect to our neighbours
enemy_naval_power = strong_memoizeNN | function(empire)
  local median = {}

  local other_naval_power = 0
  local hostile_naval_power = 0
  for other ; empire.contactable_empires
    if not other.is_minor
      local intel = empire:known_intel(other)
      --print(other.name, intel.navy_power)

      median[#median+1] = intel.navy_power

      other_naval_power = max(other_naval_power, intel.navy_power)
      if intel.hostile
        hostile_naval_power += intel.navy_power
      end
    end
  end

  -- calculate median
  table.sort(median)

  if not next(median)
    median = 0
  elseif #median % 2 == 0
    median = (median[#median/2] + median[#median/2 + 1])/2
  else
    median = median[ceil(#median)]
  end

  return max(other_naval_power, hostile_naval_power), median
end
