_ENV = AIContext

function tank_need_metric(planet)

  --don't bother if the planet is undeveloped and there is no revolt chance
  if not fully_developed(planet) and planet:chance_to_revolt() == 0
    return
  end

  if planet:has_sufficient_tanks(1) 
    return
  end

  local rebel_power,defender_power = mem_revolt_ratings(planet)


  -- if there are no potential rebels, don't use this tank
  -- building callback unless the planet is fully improved
  if rebel_power==0 and not fully_developed(planet) 
    return
  end


  if (defender_power > (rebel_power + 2) ) and  ( not fully_developed(planet) )
    return
  end



  local defenders,civilians = planet:recruitable_infantry()
  local unguarded = max(0, sum(civilians) - sum(defenders) - 2*planet.tanks )

  local desired_police = max(0, 1.5*rebel_power - defender_power)

  return desired_police*20 + unguarded*10 + planet.raw_hammer_production
end
