_ENV = AIContext

function init_desired_colony_ships()

  -- this ties us into the fleet routing logic.
  -- only desire colony ships isomuch as we have unused colonies
  local num_potential_colonies = nkeys(potential_colonies)
  local num_empire_planets = 0
  for planet ; empire.planets if not planet.no_colony
    num_empire_planets += 1
  end end

  local desired_new_colonies = max( num_potential_colonies*0.5, min(num_empire_planets*0.25, num_potential_colonies) )

  desired_colony_ships = ceil(desired_new_colonies) - total_colony_ships

  for planet, info ; potential_colonies
    if (info.score < 0) and empire.stars[planet.star] and (desired_colony_ships>0)
      desired_colony_ships -= 1
    end
  end

  queued_colony_ships = 0

  init_desired_outpost_ships()

  update_production_desire.colonize()

end


function dispatch.colonize()
  
  if desired_colony_ships + standby_colony_ships <=  
      queued_colony_ships + total_colony_ships
    ai_debug_print('out of colony sites!')
    return 'pass'
  end

  local planet = best_industry()

  ai_debug_print( 'dispatch.colonize', planet?.name )

  if(not planet) return 'pass' end
  local prereq_ok = tier1_prereq(planet)

  if prereq_ok=='orbitals_full'
     ai_debug_print('orbitals are full, this is wierd!') 
  
    return 'pass'
  end



  if prereq_ok=='set_production'
    ai_debug_print('was population already purchased here or something?.') 
    return 'pass'
  end

  --local critical = critical_defenses(planet) 
  --if not critical

  --

  local design_key = find_design_type(planet.empire,'Colony')

  -- if we can't build it, the problem is probably a lack of
  -- metal, in which case, we can't build colony ships anywhere.
  -- may as well pass.
  local cant = planet:cant_build_design(design_key)
  if planet:cant_build_design(design_key)
    ai_debug_print('cant build colony design!',cant,design_key,planet.name)
    return 'pass'
  end

  free_planets[planet]=nil
  queued_colony_ships++

  if next_colony_desire
    production_desires.colonize=next_colony_desire
    next_colony_desire=nil
  end 

  order.set_building_design(planet,  design_key)

  -- end

   

  --order.set_production(planet, critical_defenses(planet) or )
end
