depends 'empire_intel'

_ENV = AIContext

function init_research_desire()
  if not research_progress(empire)
    research_desire = nil
  end

  -- are we behind?
  local my_research = empire:research()

  research_desire = 1
  -- since we are monitoring their current research output, 
  -- using contactable_empires instead of known_empires here is a little less cheaty
  for other_empire ; empire.contactable_empires
    local other = empire:known_intel(other_empire)
    local their_research = other.research

    local need_research = 0
    if their_research > my_research*2
      need_research = 1.5
    elseif their_research > my_research*1.5
      need_research = 1
    elseif their_research > my_research
      need_research = 0.5
    end

    if other.hostile
      need_research *= 1.5
    end

    research_desire = max(research_desire, need_research+1)
  end

  --print(empire.name, ..research_desire)
end

function init_production_desire.research()
  init_research_desire()

  production_desires.research = 3*research_desire
end


function dispatch.research()

  local planet,research,hammers

  -- don't do anything if we're at the end of the research track
  if not research_progress( empire ) 
    --console("at the end of the research track")
    return 'pass'
  end

  ai_debug_print( 'dispatch.research', nkeys(free_planets) )

  planet = get_max_key(free_planets,|) function(p)
    if not fully_developed(p)
      return
    end

    --does the planet produce enough beakers to bother?
    local beakers = p.beaker_production
    local hammers = p.raw_hammer_production

    if 2.5*beakers > hammers
      return beakers - hammers
    end
  end

  if planet
    print(empire.name, "setting research on planet", planet.name)
    order.set_activity(planet, "Research")
    free_planets[planet]=nil
  else
    return 'pass'
  end

end