_ENV = AIContext


local function is_broke(empire)
  return empire.credits + empire:income()*2 < 0
end

--if we can avoid being forced to scrap ships by assigning planets to trade, do so
local function assign_planets_to_trade()

  local candidate_planets = {}
  for planet ; free_planets
    candidate_planets[#candidate_planets+1] = planet
  end

  table.sort(candidate_planets,|) function(p1,p2)
    local c1,c2 = p1.coin_production, p2.coin_production
    local h1,h2 = p1.raw_hammer_production, p2.raw_hammer_production
    return c1-h1 < c2-h2
  end

  local i = 1
  while is_broke(empire) and i <= #candidate_planets do
    local planet = candidate_planets[i]
    i += 1

    if not planet:cant_set_activity('Trade')
      order.set_activity(planet,'Trade')
      free_planets[planet] = nil
    end
  end

end

function trade_production_dispatch()
  reset_empire_incomes()

  if is_broke(empire)
    assign_planets_to_trade()
  end
end


